#property copyright "Scriptong"
#property link      "http://autograf.dp.ua"

#property indicator_chart_window
#property indicator_buffers 0

extern string A1 = "   ";
extern int    AnalysisBars  = 3; 
extern string A2 = "    ( )";
extern int    MinHistory    = 30;
extern string A3 = "      (0 - )";
extern int    BarsCount     = 100;
extern string A4 = "  ";
extern color  UpColor       = Blue;
extern string A5 = "  ";
extern color  DownColor     = Red;
extern string A6 = "  (0-4)";
extern int    LineWidth     = 4;
extern string A7 = "   0  (0-4): ,   ..";
extern int    LineStyle     = 0;
extern string A8 = "     (true)    (false)";
extern bool   LineBack      = true;
extern string A9 = "  ";
extern color  EtalonColor   = DodgerBlue;
extern string A10 = "  ";
extern color  HistoricalPatternColor = Aqua;

int high[],                                        //    ..
                                                   // ..  (-1 - ..
                                                   // ..  , 0 - ,..
                                                   // ..1 - )
    low[],                                         //    ..
                                                   // ..  (-1 - ..
                                                   // ..  , 0 - ,..
                                                   // ..1 - )
    candle_type[],                                 //     
                                                   // ..   ..
                                                   // ..(-1 -  , 0 - ,..
                                                   // ..1 -  )
    AverHighToOpen,                                //    High ..
                                                   // .. Open  
    MaxHighToOpen,                                 //    High..
                                                   // .. Open  
    AverOpenToLow,                                 //    Open ..
                                                   // .. Low  
    MaxOpenToLow,                                  //    Open..
                                                   // .. Low  
    PatternsTotal;                                 //  -  
int LastnBar;                                      //    ..
                                                   // ..  ( - ..
                                                   // ..  )
string prefix = "NBT_NR_";                         //    

//+-------------------------------------------------------------------------------------+
//| Custom indicator initialization function                                            |
//+-------------------------------------------------------------------------------------+
int init()
{
// - 1 - ==     ====================================
   if (AnalysisBars < 2)
   {
      Alert("   AnalysisBars.   5");
      AnalysisBars = 5;
   }
   if ((BarsCount < 2 && BarsCount != 0) || BarsCount > Bars)
   {
      Alert("   BarsCount.   2");
      BarsCount = 2;
   }
   if (MinHistory < 0)
   {
      Alert("   MinHistory.   5");
      MinHistory = 5;
   }
   if (LineWidth < 0 || LineWidth > 4)
   {
      Alert("   LineWidth.   4");
      LineWidth = 4;
   }
   if (LineStyle < 0 || LineStyle > 4)
   {
      Alert("   LineStyle.   0");
      LineStyle = 0;
   }
// - 1 - ==   =============================================================
   
// - 2 - ==   ======================================================
   ArrayResize(high, AnalysisBars);
   ArrayResize(low, AnalysisBars);
   ArrayResize(candle_type, AnalysisBars);
// - 2 - ==   =============================================================
   
   ShowVLine(Time[0]);                             //    ..
                                                   // .. 
   LastnBar = -1;                                  // ..    ,  
                                                   // ..  
   
   return(0);
}

//+-------------------------------------------------------------------------------------+
//|                                                               |
//+-------------------------------------------------------------------------------------+
void deinit()
{
   for (int i = ObjectsTotal()-1; i >= 0; i--)     //    
      if (StringSubstr(ObjectName(i), 0, StringLen(prefix)) == prefix)
         ObjectDelete(ObjectName(i));
}
//+-------------------------------------------------------------------------------------+
//|     double                                  |
//+-------------------------------------------------------------------------------------+
int DoubleCompare(double d1, double d2, double precision)
{
   double temp = d1 - d2;                          //     
                                                   // ..
   if (temp >= precision)                          //     ,..
      return(1);                                   // ..  1
   else                                            //     ,
      if (temp <= -precision)                      // ..  -1
         return(-1);
   return(0);                                      //     ,
                                                   // ..   -  0
}
//+-------------------------------------------------------------------------------------+
//|                                                       |
//+-------------------------------------------------------------------------------------+
void CreateEtalonPattern(int i)
{
   int last_index = i + AnalysisBars;              //    , ..
                                                   // ..  
   int cnt = 0;                                    //   ..
                                                   // ..
   for (int k = i; k < last_index; k++)            //     
   {
      high[cnt] = DoubleCompare(High[k], High[k+1], Point);//  
      low[cnt] = DoubleCompare(Low[k], Low[k+1], Point);//  
      candle_type[cnt] = DoubleCompare(Close[k], Open[k], Point);//  
      cnt++;
   }
}
//+-------------------------------------------------------------------------------------+
//|                                                  |
//+-------------------------------------------------------------------------------------+
bool CompareWithEtalon(int i)
{
   int last_index = i + AnalysisBars;              //    , ..
                                                   // ..  
   int cnt = 0;                                    //   ..
                                                   // ..
   for (int k = i; k < last_index; k++)            //        
   {
      if (DoubleCompare(High[k], High[k+1], Point) //   ..
                        != high[cnt])              // ..  ..
         return(false);                            // ..   , ..
                                                   // ..   
      if (DoubleCompare(Low[k], Low[k+1], Point)   //     ..
                        != low[cnt])               // .. 
         return(false);
      if (DoubleCompare(Close[k], Open[k], Point)  //    ..
                        != candle_type[cnt])       // ..  ..
         return(false);                            // ..   
      cnt++;
   }
   return(true);
}
//+-------------------------------------------------------------------------------------+
//|                                                     |
//+-------------------------------------------------------------------------------------+
int Average(int v1, int v2)                        //   v1  
{                                                  // .. 
   if (v1 == 0)                                    //  v2 -    , ..
      return(v2);                                  // ..   
   else                                            //    ..
      return(MathRound((v1 + v2)/2.0));            // ..
}
//+-------------------------------------------------------------------------------------+
//|    ,                                   |
//+-------------------------------------------------------------------------------------+
void FindDublicateEtalonPattern(int i)
{
   int last_index = Bars - AnalysisBars - 1;       //   ,  ..
                                                   // ..   ..
                                                   // .. 
   PatternsTotal = 0;                              //   
   AverHighToOpen = 0;                             //      ..
   AverOpenToLow = 0;                              // ..
   MaxHighToOpen = 0;                              //     
   MaxOpenToLow = 0;                               // .. 
   for (int k = i; k < last_index; k++)            //     ..
                                                   // ..   
      if (CompareWithEtalon(k))                    //   ..
      {                                            // .. , ..
         PatternsTotal++;                          //  -  
         int hto = MathRound((High[k-1] - Open[k-1])/Point);//    ..
                                                   // ..  
         int otl = MathRound((Open[k-1] - Low[k-1])/Point);//    ..
                                                   // ..  
         AverHighToOpen = Average(AverHighToOpen, hto);//   
         AverOpenToLow = Average(AverOpenToLow, otl);//   
         MaxHighToOpen = MathMax(hto, MaxHighToOpen);//   ..
         MaxOpenToLow = MathMax(otl, MaxOpenToLow);// ..
      }
}
//+-------------------------------------------------------------------------------------+
//|                                                   |
//+-------------------------------------------------------------------------------------+
void ShowRectangle(datetime time1, double price1, datetime time2, double price2, 
                   color Color)
{
   string name = prefix + "Rectangle" + time1;        //   :..
                                                      // .. + "Rectangle" +
   if (ObjectFind(name) < 0)                          //    
   {
      ObjectCreate(name, OBJ_RECTANGLE, 0, time1, price1, time2, price2); //  
      ObjectSet(name, OBJPROP_COLOR, Color);          //   ..
      ObjectSet(name, OBJPROP_BACK, true);            // ..    
   }
}
//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
void ShowVLine(datetime time1)
{
   string name = prefix + "VLine";                    //   :..
                                                      // .. + "VLine"
   if (ObjectFind(name) < 0)                          //    
   {
      ObjectCreate(name, OBJ_VLINE, 0, time1, 1);     //  
      ObjectSet(name, OBJPROP_COLOR, Red);            //   ..
      ObjectSet(name, OBJPROP_BACK, false);           // ..    
      ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);      //  
   }
}
//+-------------------------------------------------------------------------------------+
//|   ,                          |
//+-------------------------------------------------------------------------------------+
int GetVLineBarIndex()
{
   string name = prefix + "VLine";                    //   :..
                                                      // .. + "VLine"
   if (ObjectFind(name) < 0)                          //    , ..
      ShowVLine(Time[0]);                             // ..    
   datetime time = ObjectGet(name, OBJPROP_TIME1);    //    ,..
                                                      // ..   
   return(iBarShift(NULL, 0, time));                  //    
}
//+-------------------------------------------------------------------------------------+
//|                                                 |
//+-------------------------------------------------------------------------------------+
void DeleteAllRectangle()
{
   for (int i = ObjectsTotal()-1; i >= 0; i--)        //    
      if (StringSubstr(ObjectName(i), 0, StringLen(prefix)) == prefix)//   
                                                      // ..  prefix
         if (ObjectType(ObjectName(i)) == OBJ_RECTANGLE)//    
            ObjectDelete(ObjectName(i));              //  
   
}
//+-------------------------------------------------------------------------------------+
//|                                       |
//+-------------------------------------------------------------------------------------+
void ShowLine(datetime time1,                         //   
              double price1,                          //  1  
              double price2,                          //  2  
              bool up,                                // true -   , ..
                                                      // ..false - 
               string text)                           //  
{                                                     
   if (up)                                            //    ..
   {                                                  // .. ,  ..
      color Color = UpColor;                          // ..,   UpColor
      string name = prefix + "LineUp" + time1;        //   :..
                                                      // .. + "LineUp" + 
   }                        
   else                                               //    ..
   {                                                  // .. ,  ..
      Color = DownColor;                              // ..,   DownColor
      name = prefix + "LineDn" + time1;               //   :..
                                                      // .. + "LineDn" + 
   }                              
   if (ObjectFind(name) < 0)                          //    
   {
      ObjectCreate(name, OBJ_TREND, 0, time1, price1, time1, price2);//  
      ObjectSet(name, OBJPROP_COLOR, Color);          //  ,..
      ObjectSet(name, OBJPROP_STYLE, LineStyle);      // ..,
      ObjectSet(name, OBJPROP_WIDTH, LineWidth);      // ..,..
      ObjectSet(name, OBJPROP_BACK, LineBack);        // ..  ..
      ObjectSet(name, OBJPROP_RAY, false);            // .. ..
      ObjectSetText(name, text);                      // ..   
   }
}
//+-------------------------------------------------------------------------------------+
//|                                                             |
//+-------------------------------------------------------------------------------------+
int start()
{
// - 1 - ==    ,      ====
   int cb = IndicatorCounted();                    // - ,   
                                                   // ..   start
   if (cb > 0) cb--;                               //    ..
                                                   // ..
   int limit = MathMin(Bars - cb, BarsCount);      //    
// - 1 - ==   =============================================================      

// - 2 - ==     ==================================================
   for (int i = limit; i > 0; i--)                 //    
   {
      CreateEtalonPattern(i);                      //   
      FindDublicateEtalonPattern(i+AnalysisBars);  //  ,  ..
                                                   // ..
      if (PatternsTotal >= MinHistory)             //    
      {                                            // ..   
         double AverPrice = Open[i-1] + AverHighToOpen*Point;
         double MaxPrice = Open[i-1] + MaxHighToOpen*Point;
         ShowLine(Time[i-1], AverPrice, MaxPrice,  //    ..
                  true, "  " +         // .."   ..
                  DoubleToStr(AverHighToOpen, 0) + // .."  ..
                  ",   " +        // .."  "
                  DoubleToStr(MaxHighToOpen, 0) + "  " +  
                   DoubleToStr(PatternsTotal, 0) + " ");

         AverPrice = Open[i-1] - AverOpenToLow*Point;
         MaxPrice = Open[i-1] - MaxOpenToLow*Point;
         ShowLine(Time[i-1], AverPrice, MaxPrice,  //    ..
                  false, "  " +        // .."   ..
                  DoubleToStr(AverOpenToLow, 0) +  // .."  ..
                  ",   " +        // .."  "
                  DoubleToStr(MaxOpenToLow, 0) + "  " +  
                   DoubleToStr(PatternsTotal, 0) + " ");
      }   
   }
// - 2 - ==   =============================================================      
   
// - 3 - ==  ,    ==================
   int nBar = GetVLineBarIndex();                  //  ..
                                                   // .. 
   if (nBar == LastnBar)                           //    ..
      return(0);                                   // ..  ..
                                                   // ..,    
   DeleteAllRectangle();                           //    
   LastnBar = nBar;                                //    
   ShowRectangle(Time[nBar+1],                     //   
                 Low[iLowest(NULL, 0, MODE_LOW, AnalysisBars, nBar+1)], 
                 Time[nBar+AnalysisBars], 
                 High[iHighest(NULL, 0, MODE_HIGH, AnalysisBars, nBar+1)], EtalonColor);
   CreateEtalonPattern(nBar+1);                    //   ..
                                                   // ..
   limit = nBar + AnalysisBars + 1;                //    ..
                                                   // ..   
   int end = Bars - AnalysisBars - 1;              //     
   for (i = limit; i < end; i++)                   //    
      if (CompareWithEtalon(i))                    //    ..
         ShowRectangle(Time[i],                    // ..,   ..
                       Low[iLowest(NULL, 0, MODE_LOW, AnalysisBars, i)],
                       Time[i+AnalysisBars-1],     // ..
                       High[iHighest(NULL, 0, MODE_HIGH, AnalysisBars, i)], 
                       HistoricalPatternColor);
// - 3 - ==   =============================================================      
   
   WindowRedraw();                                 //   
   return(0);
}

